{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program ANTHILL;

const filein='ANT.IN';
      fileout='ANT.OUT';
      MAXN=70;
      eps:extended=1e-10;

var fin,fout:text;
    i,j,k,m,n,p,q,ll:longint;
    prob,pnew:array[1..MAXN] of extended;
    nvec:array[1..MAXN] of byte;
    pchoose:array[1..MAXN] of extended;
    list:array[1..MAXN,1..MAXN] of byte;
    pfin,pact,ptot:extended;
    go:boolean;

begin
assign(fin,filein);
reset(fin);

assign(fout,fileout);
rewrite(fout);

readln(fin,n);

while (n>0) do
  begin
    fillchar(list,sizeof(list),0);
    fillchar(nvec,sizeof(nvec),0);
    fillchar(prob,sizeof(prob),0);

    readln(fin,i,j);

    while (i>0) and (j>0) do
      begin
        inc(nvec[i]);
        list[i,nvec[i]]:=j;

        if (j<>i) then
          begin
            inc(nvec[j]);
            list[j,nvec[j]]:=i;
          end;

        readln(fin,i,j);
      end;

    for i:=1 to n do
      if (nvec[i]>0) then
        pchoose[i]:=1.0/nvec[i];

    if (n=1) then
      begin
        writeln(fout,'0.00');

        readln(fin,n);
        continue;
      end;

    ll:=0; pfin:=0; ptot:=0;
    prob[1]:=1;

    go:=true;
    while (go) do
      begin
        fillchar(pnew,sizeof(pnew),0);
        for i:=1 to n-1 do
          if (prob[i]>0) then
            for j:=1 to nvec[i] do
              pnew[list[i,j]]:=pnew[list[i,j]]+(prob[i]*pchoose[i]);

        move(pnew,prob,sizeof(prob));

        ll:=ll+1;
        pact:=ll*prob[n];
        pfin:=pfin+pact;

        ptot:=ptot+prob[n];

        if (1-ptot<eps) then
          go:=false;

      end;


    writeln(fout,pfin:0:2);

    readln(fin,n);
  end;

close(fin);
close(fout);
end.