{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{
Complexitate: N*sqrt(N) + N*log(N)*log(N) + 2*N*log(N)
( cazul cel mai defavorabil)
}

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 45384,0,655360}

Program MAG;

type vvect=array[1..30001] of word;
     intvect=array[1..30001] of byte;
     minvect=array[1..30001] of integer;
     buffer=array[1..65000] of char;

var fin,fout:text;
    vvn,vaux,tata,next,prev:^vvect;
    intasoc,marc,nniv:^intvect;
    minus:^minvect;
    intt:array[0..200] of integer;
    i,j,k,m,mm,n,p,q,rad,nint:integer;
    aaux:word;
    buf:^buffer;
    t2:longint absolute 0:$046c;
    t1:longint;

procedure sorti(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (vvn^[li]>vvn^[ls]) then
      begin
        aaux:=vvn^[li];
        vvn^[li]:=vvn^[ls];
        vvn^[ls]:=aaux;
      end;
  end
else
  if (ls-li>1) then
    begin
      sorti(li,(li+ls) shr 1);
      sorti((li+ls) shr 1 +1,ls);

      k:=li-1;
      i:=li;
      mm:=(li+ls) shr 1;
      j:=mm+1;

      while (i<=mm) and (j<=ls) do
        begin
          inc(k);
          if (vvn^[i]<vvn^[j]) then
            begin
              vaux^[k]:=vvn^[i];
              inc(i);
            end
          else
            begin
             vaux^[k]:=vvn^[j];
             inc(j);
            end;
        end;

      if (i<=mm) then
        begin
          for j:=i to mm do
            begin
              inc(k);
              vaux^[k]:=vvn^[j];
            end;
        end
      else
        begin
          for i:=j to ls do
            begin
              inc(k);
              vaux^[k]:=vvn^[i];
            end;
        end;

      for k:=li to ls do
        vvn^[k]:=vaux^[k];

    end;
end;

procedure cbinar(li,ls,vc:integer);
var r1,r2,rr:integer;
begin

if (marc^[li]=1) then
  begin
    while (tata^[li]>0) do
      li:=tata^[li];
    li:=next^[li];
  end;

if (marc^[ls]=1) then
  begin
    while (tata^[ls]>0) do
      ls:=tata^[ls];
    ls:=prev^[ls];
  end;

if (ls<li) then exit;

r1:=(li+ls) shr 1;
r2:=r1+minus^[r1]+intt[intasoc^[r1]];

if (marc^[r1]=0) then
  begin
    if (r2<vc) then
      cbinar(r1+1,ls,vc)
    else
      if (r2>vc) then
        cbinar(li,r1-1,vc)
      else
        p:=r1;
  end
else
  begin
    rr:=r1;
    while (tata^[rr]>0) do
      rr:=tata^[rr];

    r1:=prev^[rr]; r2:=next^[rr];

    rr:=r1+minus^[r1]+intt[intasoc^[r1]];

    if (vc<=rr) then
      cbinar(li,r1,vc)
    else
      begin
        rr:=r2+minus^[r2]+intt[intasoc^[r2]];
        if (vc>=rr) then
          cbinar(r2,ls,vc);
      end
  end;
end;


begin
t1:=t2;

new(vvn);
fillchar(vvn^,sizeof(vvn^),0);

assign(fin,'MAG.IN');
reset(fin);
readln(fin,n,m);

for i:=1 to n do
  readln(fin,vvn^[i]);

new(vaux);
fillchar(vaux^,sizeof(vaux^),0);
sorti(1,n);

dispose(vaux);

new(tata);
fillchar(tata^,sizeof(tata^),0);
new(nniv);
fillchar(nniv^,sizeof(nniv^),0);
new(next);
fillchar(next^,sizeof(next^),0);
new(prev);
fillchar(prev^,sizeof(prev^),0);
new(intasoc);
fillchar(intasoc^,sizeof(intasoc^),0);
new(marc);
fillchar(marc^,sizeof(marc^),0);
new(minus);
fillchar(minus^,sizeof(minus^),0);

fillchar(intt,sizeof(intt),0);

rad:=trunc(sqrt(N));
nint:=n div rad;

for i:=1 to n+1 do
  begin
    intasoc^[i]:=i div rad;
    next^[i]:=i;
    prev^[i]:=i;
  end;

new(buf);
fillchar(buf^,sizeof(buf^),0);

assign(fout,'MAG.OUT');
settextbuf(fout,buf^,sizeof(buffer));

rewrite(fout);

for i:=1 to m do
  begin
    p:=0;

    readln(fin,mm);
    cbinar(1,n,mm);

    writeln(fout,vvn^[p]);

    marc^[p]:=1;
    next^[p]:=p+1;
    prev^[p]:=p-1;

    { Disjoint sets }

    if (p>1) and (marc^[p-1]=1) then
      begin
        j:=p-1;
        while (tata^[j]>0) do
          j:=tata^[j];

        tata^[p]:=j;
        if (nniv^[j]=0) then nniv^[j]:=1;
        next^[j]:=next^[p];
      end;

    if (p<n) and (marc^[p+1]=1) then
      begin
        j:=p;
        while (tata^[j]>0) do
          j:=tata^[j];

        k:=p+1;
        while (tata^[k]>0) do
          k:=tata^[k];

        if (nniv^[j]>nniv^[k]) then
          begin
            tata^[k]:=j;
            next^[j]:=next^[k];
          end
        else
          if (nniv^[j]<nniv^[k]) then
            begin
              tata^[j]:=k;
              prev^[k]:=prev^[j];
            end
          else
            begin
              tata^[k]:=j;
              next^[j]:=next^[k];
              inc(nniv^[j]);
            end;
      end;


    { 
     "Refresh" the interval of p and the other
      sqrt(N) intervals  
    }
    
    j:=p+1;
    while (j<=n) and (intasoc^[j]=intasoc^[p]) do
      begin
        dec(minus^[j]);
        j:=j+1;
      end;

    for j:=intasoc^[p]+1 to nint do
      dec(intt[j]);

  end;

close(fin);
close(fout);

writeln(t2-t1);
end.