{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 16384,0,655360}

Program NAILS;

const filein='NAI.IN';
      fileout='NAI.OUT';
      MAXI=10000;

type intervalarray=array[0..2*MAXI+1] of integer;
     nailsarray=array[0..MAXI] of longint;

var fin,fout:text;
    i,j,k,m,n:integer;
    need,nailed,start:^nailsarray;
    inn,innaux,inno,innoaux:^intervalarray;
    vaux,nnails,alreadynailed:longint;

procedure sorti(li,ls:integer);
begin
if (ls-li=1) then
  begin
    if (inn^[li]>inn^[ls]) then
      begin
        vaux:=inn^[li];
        inn^[li]:=inn^[ls];
        inn^[ls]:=vaux;

        vaux:=inno^[li];
        inno^[li]:=inno^[ls];
        inno^[ls]:=vaux;
      end;
  end
else
  if (ls-li>1) then
    begin
      sorti(li,(li+ls) shr 1);
      sorti((li+ls) shr 1 +1,ls);

      k:=li-1;
      i:=li;
      m:=(li+ls) shr 1;
      j:=m+1;

      while (i<=m) and (j<=ls) do
        begin
          inc(k);

          if (inn^[i]<inn^[j]) then
            begin
              innaux^[k]:=inn^[i];
              innoaux^[k]:=inno^[i];
              inc(i);
            end
          else
            begin
              innaux^[k]:=inn^[j];
              innoaux^[k]:=inno^[j];
              inc(j);
            end;
        end;

      if (i<=m) then
        begin
          for j:=i to m do
            begin
              inc(k);
              innaux^[k]:=inn^[j];
              innoaux^[k]:=inno^[j];
            end;
        end
      else
        begin
          for i:=j to ls do
            begin
              inc(k);
              innaux^[k]:=inn^[i];
              innoaux^[k]:=inno^[i];
            end;
        end;

      for k:=li to ls do
        begin
          inn^[k]:=innaux^[k];
          inno^[k]:=innoaux^[k];
        end;
    end;
end;

begin

new(need);
fillchar(need^,sizeof(need^),0);
new(nailed);
fillchar(nailed^,sizeof(nailed^),0);
new(start);
fillchar(start^,sizeof(start^),0);

new(inn);
fillchar(inn^,sizeof(inn^),0);
new(inno);
fillchar(inno^,sizeof(inno^),0);

assign(fin,filein);
reset(fin);

readln(fin,n);

for i:=1 to n do
  begin
    readln(fin,need^[i],inn^[2*i-1],inn^[2*i]);
    inno^[2*i-1]:=i;
    inno^[2*i]:=-i;
  end;

close(fin);

new(innaux);
fillchar(innaux^,sizeof(innaux^),0);
new(innoaux);
fillchar(innoaux^,sizeof(innoaux^),0);

sorti(1,2*n);

for i:=1 to 2*n do
  if (inno^[i]>0) then
    start^[inno^[i]]:=i;

nnails:=0;
nailed^[0]:=0;

for i:=1 to 2*n do
  if (inno^[i]>0) then
    nailed^[i]:=nailed^[i-1]
  else
    begin
      nailed^[i]:=nailed^[i-1];

      alreadynailed:=nailed^[i]-nailed^[start^[abs(inno^[i])]];

      if (alreadynailed<need^[abs(inno^[i])]) then
        begin
          nnails:=nnails+need^[abs(inno^[i])]-alreadynailed;
          nailed^[i]:=nailed^[i]+
                      need^[abs(inno^[i])]-alreadynailed;
        end;
    end;

assign(fout,fileout);
rewrite(fout);
writeln(fout,nnails);
close(fout);
end.